#! /usr/bin/env python
# -*- coding: utf-8 -*-

from Protein import *
from DNA import *
from RNA import *
import sys, DNA, RNA, Protein
from checkFile import *

# def chooseMethod(fastas, seqType, encoding, kValue, weight, mismatch, delta, lag, phyche_list_file, extra_index_file, all_prop, cp, gap, neg_source, raactype, subtype):
def chooseMethod(fastas, seqType, encoding, kValue, positiveSource, negativeSource, mismatch, delta, lag, phyche_vals, phyche_list_file, all_prop, lamada, weight, oligonucleotide, max_distance, cp, gap, nlag, train, label, subtype, gap_lambda, argsType, raactype, path, frequency_file, finalist, smoothing_window, sliding_window, Xi, Alpha):
    if seqType == "DNA":
        if not checkDNA(fastas):
            sys.exit('Error,the character must be ACGT!')
        if encoding == "Kmer":
            return DNA.Kmer.make_kmer_vector(fastas, kValue)
        if encoding == "RevKmer":
            return DNA.RevKmer.make_kmer_vector(fastas, kValue)
        if encoding == "IDKmer":
            return DNA.IDKmer.idkmer(fastas, kValue, positiveSource, negativeSource)
        if encoding == "Mismatch":
            return DNA.Mismatch.getMismatchProfileMatrix(fastas, kValue, mismatch)
        if encoding == "Subsequence":
            return DNA.Subsequence.getSubsequenceProfileByParallel(fastas, kValue, delta)
        if encoding == "DAC":
            return DNA.KAC.make_ac_vec(fastas, lag, phyche_vals, 2)
        if encoding == "DCC":
            return DNA.KCC.make_cc_vec(fastas, lag, phyche_vals, 2)
        if encoding == "DACC":
            return DNA.KACC.make_acc_vec(fastas, lag, phyche_vals, 2)
        if encoding == "TAC":
            return DNA.KAC.make_ac_vec(fastas, lag, phyche_vals, 3)
        if encoding == "TCC":
            return DNA.KCC.make_cc_vec(fastas, lag, phyche_vals, 3)
        if encoding == "TACC":
            return DNA.KACC.make_acc_vec(fastas, lag, phyche_vals, 3)
        if encoding == "MAC":
            return DNA.MAC.autocorrelation(fastas, oligonucleotide, lamada, phyche_list_file, all_prop)
        if encoding == "GAC":
            return DNA.GAC.autocorrelation(fastas, oligonucleotide, lamada, phyche_list_file, all_prop)
        if encoding == "NMBAC":
            return DNA.NMBAC.autocorrelation(fastas, oligonucleotide, lamada, phyche_list_file, all_prop)
        if encoding == "PseDNC" or encoding == "PC-PseDNC-General":
            return DNA.PseKNC.make_pseknc_vector(fastas, 2, weight, lamada, phyche_vals, 1)
        if encoding == "PseKNC":
            return DNA.PseKNC.make_pseknc_vector(fastas, kValue, weight, lamada, phyche_vals, 0)
        if encoding == "PC-PseTNC-General":
            return DNA.PseKNC.make_pseknc_vector(fastas, 3, weight, lamada, phyche_vals, 1)
        if encoding == "SC-PseDNC-General":
            return DNA.PseKNC.make_pseknc_vector(fastas, 2, weight, lamada, phyche_vals, 2)
        if encoding == "SC-PseTNC-General":
            return DNA.PseKNC.make_pseknc_vector(fastas, 3, weight, lamada, phyche_vals, 2)
    if seqType == "RNA":
        if encoding not in ['Triplet','PseSSC','PseDPC']:
            if not checkRNA(fastas):
                sys.exit('Error,the character must be ACGU!')
            if encoding == "Kmer":
                return RNA.Kmer.make_kmer_vector(fastas, kValue)
            if encoding == "Mismatch":
                return RNA.Mismatch.getMismatchProfileMatrix(fastas, kValue, mismatch)
            if encoding == "Subsequence":
                return RNA.Subsequence.getSubsequenceProfileByParallel(fastas, kValue, delta)
            if encoding == "DAC":
                return RNA.DAC.make_ac_vec(fastas, lag, phyche_vals, 2)
            if encoding == "DCC":
                return RNA.DCC.make_cc_vec(fastas, lag, phyche_vals, 2)
            if encoding == "DACC":
                return RNA.DACC.make_acc_vec(fastas, lag, phyche_vals, 2)
            if encoding == "MAC":
                return RNA.MAC.autocorrelation(fastas, 2, lamada, phyche_list_file, all_prop)
            if encoding == "GAC":
                return RNA.GAC.autocorrelation(fastas, 2, lamada, phyche_list_file, all_prop)
            if encoding == "NMBAC":
                return RNA.NMBAC.autocorrelation(fastas, 2, lamada, phyche_list_file, all_prop)
            if encoding == "PC-PseDNC-General":
                return RNA.PseDNC.make_pseknc_vector(fastas, 2, weight, lamada, phyche_vals, 1)
            if encoding == "SC-PseDNC-General":
                return RNA.PseDNC.make_pseknc_vector(fastas, 2, weight, lamada, phyche_vals, 2)
        else:
            if encoding == "Triplet":
                return RNA.Triplet.get_triplet_matrix(fastas)
            if encoding == "PseSSC":
                return RNA.PseSSC.get_psessc_matrix(fastas, kValue, lamada, weight)
            if encoding == "PseDPC":
                return RNA.PseDPC.get_psedpc_matrix(fastas, kValue, lamada, weight)
    if seqType == "Protein":
        if encoding == "PDT":
            return PDT.pdt(fastas, lamada)
        #check fasta file
        if not checkProtein(fastas):
            sys.exit('Error,the character must be ACDEFGHIKLMNPQRSTVWY!')
        if encoding == "Kmer":
            return Protein.Kmer.make_kmer_vector(fastas, kValue)
        if encoding == "DR":
            return DR.dr_method(fastas, max_distance)
        if encoding == "DP":
            return DP.get_pseaacdis_matrix(fastas, max_distance, cp)
        if encoding == "AC":
            return AC.make_ac_vec(fastas, lag, phyche_vals, 1)
        if encoding == "CC":
            return CC.make_cc_vec(fastas, lag, phyche_vals, 1)
        if encoding == "ACC":
            return ACC.make_acc_vec(fastas, lag, phyche_vals, 1)
        if encoding == "PC-PseAAC-General" or encoding == "PC-PseAAC" or encoding == "PAAC":
            return PseAAC.make_pseknc_vector(fastas, 1, weight, lamada, phyche_vals, 1)
        if encoding == "SC-PseAAC-General" or encoding == "SC-PseAAC" or encoding == "APAAC":
            return PseAAC.make_pseknc_vector(fastas, 1, weight, lamada, phyche_vals, 2)
        if encoding == "EAAC":
            return EAAC.EAAC(fastas, sliding_window)
        if encoding == "CKSAAP":
            return CKSAAP.CKSAAP(fastas, gap)
        if encoding == "DDE":
            return DDE.DDE(fastas)
        if encoding == "GAAC":
            return GAAC.GAAC(fastas)
        if encoding == "EGAAC":
            return EGAAC.EGAAC(fastas, sliding_window)
        if encoding == "CKSAAGP":
            return CKSAAGP.CKSAAGP(fastas, gap)
        if encoding == "GDPC":
            return GDPC.GDPC(fastas)
        if encoding == "GTPC":
            return GTPC.GTPC(fastas)
        if encoding == "BINARY":
            return BINARY.BINARY(fastas)
        if encoding == "Moran":
            return Moran.Moran(fastas, phyche_list_file, nlag)
        if encoding == "Geary":
            return Geary.Geary(fastas, phyche_list_file, nlag)
        if encoding == "NMBroto":
            return NMBroto.NMBroto(fastas, phyche_list_file, nlag)
        if encoding == "CTDC":
            return CTDC.CTDC(fastas)
        if encoding == "CTDT":
            return CTDT.CTDT(fastas)
        if encoding == "CTDD":
            return CTDD.CTDD(fastas)
    #     if encoding == "CTDCClass":
    #         return CTDCClass.CTDCClass(fastas, gap)
    #     if encoding == "CTDTClass":
    #         return CTDTClass.CTDTClass(fastas, gap)
    #     if encoding == "CTDDClass":
    #         return CTDDClass.CTDDClass(fastas, gap)
        if encoding == "CTriad":
            return CTriad.CTriad(fastas)
        if encoding == "KSCTriad":
            return KSCTriad.KSCTriad(fastas, kValue)
        if encoding == "QSOrder":
            return QSOrder.QSOrder(fastas, nlag, weight)
        if encoding == "SOCNumber":
            return SOCNumber.SOCNumber(fastas, nlag)
        if encoding == "KNNprotein":
            return KNNprotein.KNNprotein(fastas, train, label)
        if encoding == "KNNpeptide":
            return KNNpeptide.KNNpeptide(fastas, train, label)
        if encoding == "AAINDEX":
            return AAINDEX.AAINDEX(fastas)
        if encoding == "BLOSUM62":
            return BLOSUM62.BLOSUM62(fastas)
        if encoding == "ZSCALE":
            return ZSCALE.ZSCALE(fastas)
        if encoding == "SSEC":
            return SSEC.SSEC(fastas, path)
        if encoding == "SSEB":
            return SSEB.SSEB(fastas, path)
        if encoding == "Disorder":
            return Disorder.Disorder(fastas, path)
        if encoding == "DisorderC":
            return DisorderC.DisorderC(fastas, path)
        if encoding == "DisorderB":
            return DisorderB.DisorderB(fastas, path)
        if encoding == "ASA":
            return ASA.ASA(fastas, path)
        if encoding == "TA":
            return TA.TA(fastas, path)
        if encoding == "PseKRAAC":
            return PseKRAAC.PseKRAAC(fastas, argsType, subtype, raactype, kValue, gap_lambda)
        if encoding == "NUM":
            return NUM.NUM(fastas)
        if encoding == "EBGW":
            return EBGW.EBGW(fastas, lamada)
        if encoding == "LOGO":
            return LOGO.LOGO(fastas, frequency_file)
        if encoding == "LOGO-P-Value":
            return LOGO_P_Value.LOGO_P_Value(fastas, frequency_file)
        if encoding == "LOGO-BLOSUM62":
            return LOGO_BLOSUM62.LOGO_BLOSUM62(fastas, frequency_file)
        if encoding=="AAC-PSSM":
            return AAC_PSSM.AAC_PSSM_LOOP(finalist)
        if encoding=="D-FPSSM":
            return D_FPSSM.D_FPSSM_LOOP(finalist)
        if encoding=="smoothed-PSSM":
            return smoothed_PSSM.smoothed_PSSM_LOOP(finalist, smoothing_window, sliding_window)
        if encoding=="AB-PSSM":
            return AB_PSSM.AB_PSSM_LOOP(finalist)
        if encoding=="PSSM-composition":
            return PSSM_composition.PSSM_composition_LOOP(finalist)
        if encoding=="RPM-PSSM": 
            return RPM_PSSM.RPM_PSSM_LOOP(finalist)
        if encoding=="S-FPSSM":
            return S_FPSSM.S_FPSSM_LOOP(finalist)
        if encoding=="DPC-PSSM":
            return DPC_PSSM.DPC_PSSM_LOOP(finalist)
        if encoding=="k-separated-bigrams-PSSM":
            return k_separated_bigrams_PSSM.k_separated_bigrams_PSSM_LOOP(finalist, kValue)
        if encoding=="tri-gram-PSSM":
            return tri_gram_PSSM.tri_gram_PSSM_LOOP(finalist)
        if encoding=="EEDP":
            return EEDP.EEDP_LOOP(finalist)
        if encoding=="TPC":
            return TPC.TPC_LOOP(finalist)
        if encoding=="EDP":
            return EDP.EDP_LOOP(finalist)
        if encoding=="RPSSM":
            return RPSSM.RPSSM_LOOP(finalist)
        if encoding=="Pse-PSSM":
            return Pse_PSSM.Pse_PSSM_LOOP(finalist, Xi)
        if encoding=="DP-PSSM":
            return DP_PSSM.DP_PSSM_LOOP(finalist, Alpha)
        if encoding=="PSSM-AC":
            return PSSM_AC.PSSM_AC_LOOP(finalist, lag)
        if encoding=="PSSM-CC":
            return PSSM_CC.PSSM_CC_LOOP(finalist, lag)
        if encoding=="AADP-PSSM":
            return AADP_PSSM.AADP_PSSM_LOOP(finalist)
        if encoding=="AATP":
            return AATP.AATP_LOOP(finalist)
        if encoding=="MEDP":
            return MEDP.MEDP_LOOP(finalist)
        


        
        


    
