"""
@author: Fule Liu, Nackel, luo, Hao Wu
"""
import util
import index_list
import re,sys,os

'''This code can be refactored if possible.'''
def autocorrelation(fastas, k, l, phyche_list_file, all_prop):
    if l <= 0 :
        print "parameters lamada is required. The default value of lamada is 1."
        l = 1
    if l < 0 or l > 10:
        sys.exit("Error! The value of lamada should be larger than 0 and smaller than 10.")
    props = ''
    alphabet = index_list.DNA
    if all_prop == True:
        props = index_list.ALL_DI_DNA_IND
    elif phyche_list_file == None:
        print "parameters phyche_list is required. The default value of phyche_list is ['Rise', 'Roll', 'Shift', 'Slide', 'Tilt', 'Twist']."
        props=index_list.DEFAULT_DI_DNA_IND
    else:
        props = util.read_index(phyche_list_file)
    # Getting supporting info from files
    full_path = os.path.realpath(__file__)
    if k == 2 and alphabet == index_list.RNA:
        SupFileName = "%s/data/Supporting_Information_S1_RNA.txt" % os.path.dirname(full_path)
    elif k == 2 and alphabet == index_list.DNA:
        SupFileName = "%s/data/Supporting_Information_S1_DNA.txt" % os.path.dirname(full_path)
    elif k == 3 and alphabet == index_list.DNA:
        SupFileName = "%s/data/Supporting_Information_S3_DNA.txt" % os.path.dirname(full_path)
    SupFile = open(SupFileName, 'r')
    supInfo = SupFile.read()
    o = re.search('Physicochemical properties\,(.+)\n', supInfo)
    olinucs = ''
    if o:
        olinucs = o.group(1).rstrip()
    SupFile.close()
    # Writing to output file
    m = 0
    vectors = []
    for sequence in fastas:
        length = len(sequence[1])
        seq = util.sepSequence(sequence[1], k)
        values = []
        for prop in props:
            #check if prop is in supinfo
            if (k == 2 and prop in index_list.ALL_DI_DNA_IND) or (k == 3 and prop in index_list.ALL_TRI_DNA_IND):
                value = float("%.3f" % moreau(seq, olinucs, length, k, l, prop, supInfo))
                values.append(value)
            else:
                print "%s is not in Physicochemical properties list." % prop
        vectors.append(values)
        m += 1
    return vectors

def moreau(seq, olinucs, length, k, l, prop, supInfo):
    limit = length - k - l + 1
    d = 1
    prod = 0
    while d < limit or d == limit:
        current = util.getSpecificValue(seq[d - 1], olinucs, prop, supInfo)
        # hn(seq[d-1],prop,SupFileName)
        next = util.getSpecificValue(seq[d + l - 1], olinucs, prop, supInfo)
        # hn(seq[d+l-1],prop,SupFileName)
        prod = prod + (current * next)
        d = d + 1
    final = prod / limit
    return final