#! /usr/bin/env python
# -*- coding: utf-8 -*-
"""
@author: Fule Liu, Nackel, luo, Hao Wu
"""
import re,sys,util
import index_list

def make_kmer_vector(fastas,k):
    vector = []
    if k <= 0:
        print "parameters kValue is required. The default value of k is 2."
        k = 2
    alphabet = index_list.DNA
    if re.search(r'[^acgtACGT]', ''.join(alphabet)) is not None:
            sys.exit("Error, Only DNA sequence can be reverse compliment.")
    kmer_list = util.make_kmer_list(k, alphabet)
    for seq in fastas:
        count_sum = 0
        # Generate the kmer frequency dict.
        kmer_count = {}
        for kmer in kmer_list:
            temp_count = util.frequency(seq[1], kmer)
            rev_kmer = util.find_revcomp(kmer, {})
            if kmer <= rev_kmer:
                if kmer not in kmer_count:
                    kmer_count[kmer] = 0
                kmer_count[kmer] += temp_count
            else:
                if rev_kmer not in kmer_count:
                    kmer_count[rev_kmer] = 0
                kmer_count[rev_kmer] += temp_count
            count_sum += temp_count
        # Normalize.
        revc_kmer_list = util.make_revcomp_kmer_list(kmer_list)
        count_vec = [kmer_count[kmer] for kmer in revc_kmer_list]
        count_vec = [round(float(e)/count_sum, 8) for e in count_vec]

        vector.append(count_vec)

    return vector


