#! /usr/bin/env python
# -*- coding: utf-8 -*-
# Authors: Chris (chris@nohup.cc) & Young (young@nohup.cc)

import fileinput
import numpy as np
import util
from AAC_PSSM import *
from DPC_PSSM import *

def AADP_PSSM_LOOP(finalist):
    encodings=[]
    for fi in finalist:
        input_matrix=fileinput.input(fi)
        input_matrix=util.readToMatrix(input_matrix)
        encodings.append(aadp_pssm(input_matrix)[0])
    return encodings


def aadp_pssm(input_matrix):
    aac_pssm_matrix=aac_pssm(input_matrix)
    dpc_pssm_matrix=dpc_pssm(input_matrix)
    aac_pssm_matrix=np.array(aac_pssm_matrix)
    dpc_pssm_matrix=np.array(dpc_pssm_matrix)
    aadp_pssm_matrix=np.hstack((aac_pssm_matrix, dpc_pssm_matrix))
    #print np.shape(aadp_pssm_matrix)
    return aadp_pssm_matrix