#!/usr/bin/env python
#_*_coding:utf-8_*_
# Authors: Superzchen

from __future__ import division
import sys, os, re, platform
import util

def AAINDEX(fastas, **kw):
	if util.checkFasta(fastas) == False:
		print('Error: for "AAINDEX" encoding, the input fasta sequences should be with equal length. \n\n')
		return 0

	AA = 'ARNDCQEGHILKMFPSTWYV'

	fileAAindex = os.path.dirname(os.path.realpath(__file__)) + r'\data\AAindex.txt' if platform.system() == 'Windows' else os.path.dirname(os.path.realpath(__file__)) + '/data/AAindex.txt'
	with open(fileAAindex) as f:
		records = f.readlines()[1:]

	AAindex = []
	AAindexName = []
	for i in records:
		AAindex.append(i.rstrip().split()[1:] if i.rstrip() != '' else None)
		AAindexName.append(i.rstrip().split()[0] if i.rstrip() != '' else None)

	index = {}
	for i in range(len(AA)):
		index[AA[i]] = i

	encodings = []


	for i in fastas:
		name, sequence = i[0], i[1]
		code = []
		for aa in sequence:
			if aa == '-':
				for j in AAindex:
					code.append(0)
				continue
			for j in AAindex:
				code.append(float(j[index[aa]]))
		encodings.append(code)
	return encodings