#! /usr/bin/env python
# -*- coding: utf-8 -*-
# Authors: Chris (chris@nohup.cc) & Young (young@nohup.cc)

import fileinput
import numpy as np
from AAC_PSSM import *
import util

def AB_PSSM_LOOP(finalist):
    encodings=[]
    for fi in finalist:
        input_matrix=fileinput.input(fi)
        input_matrix=util.readToMatrix(input_matrix)
        encodings.append(ab_pssm(input_matrix)[0])
    return encodings

def ab_pssm(input_matrix):
    #print "start ab_pssm function"
    seq_cn=np.shape(input_matrix)[0]
    BLOCK=seq_cn/20
    #print BLOCK
    matrix_final=[]
    for i in range(19):
        tmp=input_matrix[i*BLOCK:(i+1)*BLOCK]
        #print tmp
        matrix_final.append(aac_pssm(tmp)[0])
    tmp=input_matrix[19*BLOCK:]
    #print tmp
    matrix_final.append(aac_pssm(tmp)[0])
    ab_pssm_matrix=util.average(matrix_final,1.0)
    #print "finish ab_pssm function"
    return ab_pssm_matrix