#!/usr/bin/env python
#_*_coding:utf-8_*_
# Authors: Superzchen

from __future__ import division
import sys, os, re

def Count(seq1, seq2):
	sum = 0
	for aa in seq1:
		sum = sum + seq2.count(aa)
	return sum

def CTDCClass(fastas, groups):
	encodings = []
	groups = groups.split(':')
	myStr = ''.join(groups)
	myStr = re.sub('[^ACDEFGHIKLMNPQRSTVWY]', '', myStr)
	if len(myStr) != 20 or len(set(myStr)) != 20:
		print('\nERROR: The amino acid must be no-repeat in each groups and the sum is 20!\n')
	for i in fastas:
		name, sequence = i[0], re.sub('-', '', i[1])
		code = []
		for group in groups:
			code.append(Count(group, sequence) / len(sequence))
		encodings.append(code)
	return encodings

