#!/usr/bin/env python
#_*_coding:utf-8_*_
# Authors: Superzchen

from __future__ import division
import sys, os, re, math


def Count(aaSet, sequence):
	number = 0
	for aa in sequence:
		if aa in aaSet:
			number = number + 1
	cutoffNums = [1, math.floor(0.25 * number), math.floor(0.50 * number), math.floor(0.75 * number), number]
	myCount = 0
	code = []
	for i in range(len(sequence)):
		if sequence[i] in aaSet:
			myCount = myCount + 1
			if myCount in cutoffNums:
				code.append((i+1)/len(sequence) * 100)
	return code

def CTDDClass(fastas, groups):
	encodings = []
	groups = groups.split(':')
	myStr = ''.join(groups)
	myStr = re.sub('[^ACDEFGHIKLMNPQRSTVWY]', '', myStr)
	if len(myStr) != 20 or len(set(myStr)) != 20:
		print('\nERROR: The amino acid must be no-repeat in each groups and the sum is 20!\n')

	for i in fastas:
		name, sequence = i[0], re.sub('-', '', i[1])
		code = []
		for group in groups:
			code = code + Count(group, sequence)
		encodings.append(code)

	return encodings

