#! /usr/bin/env python
# -*- coding: utf-8 -*-
# Authors: Chris (chris@nohup.cc) & Young (young@nohup.cc)

import fileinput
import numpy as np
import util

def DPC_PSSM_LOOP(finalist):
    encodings=[]
    for fi in finalist:
        input_matrix=fileinput.input(fi)
        input_matrix=util.readToMatrix(input_matrix)
        encodings.append(dpc_pssm(input_matrix)[0])
    return encodings


def dpc_pssm(input_matrix):
    #print "start dpc_pssm function"
    PART = 0
    STEP = 1
    ID = 0
    KEY = 0
    matrix_final = util.preHandleColumns(input_matrix, STEP, PART, ID)
    seq_cn = float(np.shape(input_matrix)[0])
    dpc_pssm_vector = util.average(matrix_final, seq_cn-STEP)
    #print "end dpc_pssm function"
    return dpc_pssm_vector