#! /usr/bin/env python
# -*- coding: utf-8 -*-
"""
@author: Fule Liu, Nackel, luo, Hao Wu
"""
import util
import index_list

def dr_method(fastas, max_dis):
    """
    The Distance Residue method.
    :param inputfile: the input sequence file.
    :param max_dis: the value of the maximum distance.
    """
    if max_dis <= 0:
        print 'parameters max_distance is required. The default value of max_distance is 3.'
        max_dis = 3
    max_dis = int(max_dis)
    if max_dis < 0 or max_dis > 10:
        print 'The max distance can not be negative integer and should be smaller than 11.'
        return False
    if int(max_dis) > 0:
        aa_pairs = util.make_kmer_list(2, index_list.PROTEIN)
    aa_list = list(index_list.PROTEIN)
    vector_list = []

    for line in fastas:
        vector = []
        # if line.strip().startswith('>'):
        #     continue
        #line = list(line.strip())
        len_line = len(line[1])
        for i in xrange(max_dis + 1):
            if i == 0:
                temp = [line[1].count(j) for j in aa_list]
                vector.extend(temp)
            else:
                new_line = []
                for index, elem in enumerate(line[1]):
                    if (index + i) < len_line:
                        new_line.append(line[1][index] + line[1][index+i])
                temp = [new_line.count(j) for j in aa_pairs]
                vector.extend(temp)
        vector_list.append(vector)
    return vector_list