#! /usr/bin/env python
# -*- coding: utf-8 -*-
# Authors: Chris (chris@nohup.cc) & Young (young@nohup.cc)

import fileinput
import numpy as np
import util

def D_FPSSM_LOOP(finalist):
    encodings=[]
    for fi in finalist:
        input_matrix=fileinput.input(fi)
        input_matrix=util.readToMatrix(input_matrix)
        encodings.append(d_fpssm(input_matrix)[0])
    return encodings

def d_fpssm(input_matrix):
    #print "start d_fpssm function"
    SWITCH = 1
    COUNT = 20
    d_fpssm_matrix=util.handleRows(input_matrix,SWITCH,COUNT)
    seqLen = float(np.shape(input_matrix)[0])
    seq_cn = 1.0
    element_max = np.amax(d_fpssm_matrix[0], axis=0)
    element_min = np.amin(d_fpssm_matrix[0], axis=0)
    d_fpssm_vector=util.average(d_fpssm_matrix, seq_cn)
    d_fpssm_vector=np.add(d_fpssm_vector, -element_min)
    d_fpssm_vector=np.divide(d_fpssm_vector, element_max)
    d_fpssm_vector=np.divide(d_fpssm_vector, seqLen)
    #print "end d_fpssm function"
    return d_fpssm_vector