#!/usr/bin/env python
#_*_coding:utf-8_*_
# Authors: Superzchen

from __future__ import division
import re, sys, os
from collections import Counter
import util


"""
USAGE:
	input.fasta:      the input protein sequence file in fasta format.
	sliding_window:   the sliding window, integer, defaule: 5
"""

def EAAC(fastas, window=5, **kw):
	if util.checkFasta(fastas) == False:
		print('Error: for "EAAC" encoding, the input fasta sequences should be with equal length. \n\n')
		return 0
	if window <= 0:
		print "parameters window is required. The default value of window is 5."
		window = 5

	if util.minSequenceLength(fastas) < window:
		print('Error: all the sequence length should be larger than the sliding window :' + str(window) + '\n\n')
		return 0

	AA = 'ACDEFGHIKLMNPQRSTVWY'
	#AA = 'ARNDCQEGHILKMFPSTWYV'
	encodings = []

	for i in fastas:
		name, sequence = i[0], i[1]
		code = []
		for j in range(len(sequence)):
			if j < len(sequence) and j + window <= len(sequence):
				count = Counter(re.sub('-', '', sequence[j:j+window]))
				for key in count:
					count[key] = count[key] / len(re.sub('-', '', sequence[j:j+window]))
				for aa in AA:
					code.append(count[aa])
		encodings.append(code)
	return encodings


