#! /usr/bin/env python
# -*- coding: utf-8 -*-

from numpy import *
import re,util

def EBGW(fastas, lamada):

	if util.checkFasta(fastas) == False:
		print('Error: for "EBGW" encoding, the input fasta sequences should be with equal length. \n\n')
		return 0
	if util.minSequenceLength(fastas) < lamada:
		print('Error: all the sequence length should be larger than the parameter lamada :' + str(lamada) + '\n\n')
		return 0
	if lamada <= 0 :
        	print "parameters lamada is required. The default value of lamada is 8."
        	lamada = 8
	encodings = []
	sub = []
	#sub-sequence
	for t in range(lamada):            
		sub.append(int((t+1)*util.minSequenceLength(fastas)/lamada))

	h1 = ['A','F','G','I','L','M','P','V','W']
	h2 = ['C','N','Q','S','T','Y']
	h3 = ['H','K','R']
	h4 = ['D','E']
	c1 = h1 + h2
	c2 = h1 + h3
	c3 = h1 + h4

	for i in fastas:
		name, sequence = i[0], i[1]
		code = []
		sequence = list(sequence)
		h12 = []
		h13 = []
		h14 = []
		array1 = list(zeros(len(sequence)))
		array2 = list(zeros(len(sequence)))
		array3 = list(zeros(len(sequence)))
	        for j in range(len(sequence)):
    			if sequence[j] in c1:
				array1[j] = 1			
			if sequence[j] in c2:
				array2[j] = 1
			if sequence[j] in c3:   
				array3[j] = 1
		for g in range(len(sub)):
			h12.append(sum(array1[:sub[g]])/sub[g])
			h13.append(sum(array2[:sub[g]])/sub[g])
			h14.append(sum(array3[:sub[g]])/sub[g])
		code = h12 + h13 + h14
		encodings.append(code)
    	return encodings




