#! /usr/bin/env python
# -*- coding: utf-8 -*-
# Authors: Chris (chris@nohup.cc) & Young (young@nohup.cc)

import fileinput
import numpy as np
import util

def EDP_LOOP(finalist):
    encodings=[]
    for fi in finalist:
        input_matrix=fileinput.input(fi)
        input_matrix=util.readToMatrix(input_matrix)
        encodings.append(edp(input_matrix)[0])
    return encodings


def edp(input_matrix):
    #print "start edp function"
    STEP=2
    PART=0
    ID=1
    edp_matrix=[ [0.0] * 20 ] * 1
    edp_matrix=np.array(edp_matrix)
    seq_cn=float(np.shape(input_matrix)[0])
    output_matrix=util.preHandleColumns(input_matrix,STEP,PART,ID)
    output_matrix=np.array(output_matrix)
    for i in range(20):
        edp_matrix[0]=map(sum, zip(output_matrix[i], edp_matrix[0]))
    edp_matrix=np.divide(edp_matrix, (seq_cn-STEP)*20.0)
    #print "end edp function"
    return edp_matrix