#! /usr/bin/env python
# -*- coding: utf-8 -*-
# Authors: Chris (chris@nohup.cc) & Young (young@nohup.cc)

import fileinput
import numpy as np
import util

def EEDP_LOOP(finalist):
    encodings=[]
    for fi in finalist:
        input_matrix=fileinput.input(fi)
        input_matrix=util.readToMatrix(input_matrix)
        encodings.append(eedp(input_matrix)[0])
    return encodings


def eedp(input_matrix):
    #print "start eedp function"
    STEP = 2
    PART = 0
    ID = 1
    KEY = 0
    seq_cn = float(np.shape(input_matrix)[0])
    matrix_final = util.preHandleColumns(input_matrix, STEP, PART, ID)
    eedp_vector = util.average(matrix_final, seq_cn-STEP)
    #print "end eedp function"
    return eedp_vector