#!/usr/bin/env python
#_*_coding:utf-8_*_

from __future__ import division
import re, sys, os
from collections import Counter
import util

"""
USAGE:
	input.fasta:      the input protein sequence file in fasta format.
	sliding_window:   the sliding window, integer, defaule: 5
"""

def EGAAC(fastas, window=5, **kw):
	if util.checkFasta(fastas) == False:
		print('Error: for "EGAAC" encoding, the input fasta sequences should be with equal length. \n\n')
		return 0
	if window <= 0:
		print "parameters window is required. The default value of window is 5."
		window = 5

	group = {
		'alphaticr': 'GAVLMI',
		'aromatic': 'FYW',
		'postivecharger': 'KRH',
		'negativecharger': 'DE',
		'uncharger': 'STCPNQ'
	}

	groupKey = group.keys()
	encodings = []

	for i in fastas:
		name, sequence = i[0], i[1]
		code = []
		for j in range(len(sequence)):
			if j + window <= len(sequence):
				count = Counter(sequence[j:j + window])
				myDict = {}
				for key in groupKey:
					for aa in group[key]:
						myDict[key] = myDict.get(key, 0) + count[aa]
				for key in groupKey:
					code.append(myDict[key] / window)
		encodings.append(code)
	return encodings
