#! /usr/bin/env python
# -*- coding: utf-8 -*-

import util

def LOGO(fastas, frequence_file):

	if util.checkFasta(fastas) == False:
		print('Error: for "LOGO" encoding, the input fasta sequences should be with equal length. \n\n')
		return 0
	if frequence_file == None:
		print('Error: for "LOGO" encoding, the parameter frequence_file is required. \n\n')
		return 0

	encodings = []

	l_matrix = []
	for nu in range(util.minSequenceLength(fastas)):
	    	l_matrix.append({})
		
	i = 0
	file_object = open(frequence_file,'rU')

	try:
	    for line in file_object:
	        if(i == 0):
	                i = i + 1
	                continue
	        array_l = line.split( );
	        l_matrix[int(array_l[0])-1][array_l[1]] = float(array_l[2])
	finally:
	     file_object.close()

	for i in fastas:
		name, sequence = i[0], i[1]
		code = []

		for j in range(len(sequence)):
			if sequence[j] in l_matrix[j].keys():
				code.append(l_matrix[j][sequence[j]])
			else:
				code.append(0)

		encodings.append(code)

	return encodings
