#! /usr/bin/env python
# -*- coding: utf-8 -*-

from __future__ import division
import util
import numpy as np

def LOGO_BLOSUM62(fastas, frequence_file):

	if util.checkFasta(fastas) == False:
		print('Error: for "LOGO" encoding, the input fasta sequences should be with equal length. \n\n')
		return 0
	if frequence_file == None:
		print('Error: for "LOGO" encoding, the parameter frequence_file is required. \n\n')
		return 0

	blosum_id = ['C','S','T','P','A','G','N','D','E','Q','H','R','K','M','I','L','V','F','Y','W','O']
	blosum_matrix = [[9,-1,-1,-3,0,-3,-3,-3,-4,-3,-3,-3,-3,-1,-1,-1,-1,-2,-2,-2,-4],
	                 [-1,4,1,-1,1,0,1,0,0,0,-1,-1,0,-1,-2,-2,-2,-2,-2,-3,-4],
	                 [-1,1,4,1,-1,1,0,1,0,0,0,-1,0,-1,-2,-2,-2,-2,-2,-3,-4],
	                 [-3,-1,1,7,-1,-2,-1,-1,-1,-1,-2,-2,-1,-2,-3,-3,-2,-4,-3,-4,-4],
	                 [0,1,-1,-1,4,0,-1,-2,-1,-1,-2,-1,-1,-1,-1,-1,-2,-2,-2,-3,-4],
	                 [-3,0,1,-2,0,6,-2,-1,-2,-2,-2,-2,-2,-3,-4,-4,0,-3,-3,-2,-4],
	                 [-3,1,0,-2,-2,0,6,1,0,0,-1,0,0,-2,-3,-3,-3,-3,-2,-4,-4],
	                 [-3,0,1,-1,-2,-1,1,6,2,0,-1,-2,-1,-3,-3,-4,-3,-3,-3,-4,-4],
	                 [-4,0,0,-1,-1,-2,0,2,5,2,0,0,1,-2,-3,-3,-3,-3,-2,-3,-4],
	                 [-3,0,0,-1,-1,-2,0,0,2,5,0,1,1,0,-3,-2,-2,-3,-1,-2,-4],
	                 [-3,-1,0,-2,-2,-2,1,1,0,0,8,0,-1,-2,-3,-3,-2,-1,2,-2,-4],
	                 [-3,-1,-1,-2,-1,-2,0,-2,0,1,0,5,2,-1,-3,-2,-3,-3,-2,-3,-4],
	                 [-3,0,0,-1,-1,-2,0,-1,1,1,-1,2,5,-1,-3,-2,-3,-3,-2,-3,-4],
	                 [-1,-1,-1,-2,-1,-3,-2,-3,-2,0,-2,-1,-1,5,1,2,-2,0,-1,-1,-4],
	                 [-1,-2,-2,-3,-1,-4,-3,-3,-3,-3,-3,-3,-3,1,4,2,1,0,-1,-3,-4],
	                 [-1,-2,-2,-3,-1,-4,-3,-4,-3,-2,-3,-2,-2,2,2,4,3,0,-1,-2,-4],
	                 [-1,-2,-2,-2,0,-3,-3,-3,-2,-2,-3,-3,-2,1,3,1,4,-1,-1,-3,-4],
	                 [-2,-2,-2,-4,-2,-3,-3,-3,-3,-3,-1,-3,-3,0,0,0,-1,6,3,1,-4],
	                 [-2,-2,-2,-3,-2,-3,-2,-3,-2,-1,2,-2,-2,-1,-1,-1,-1,3,7,2,-4],
	                 [-2,-3,-3,-4,-3,-2,-4,-4,-3,-2,-2,-3,-3,-1,-3,-2,-3,1,2,11,-4],
	                 [-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,-4,1]]

	encodings = []

	l_matrix = []
	for nu in range(util.minSequenceLength(fastas)):
	    	l_matrix.append({})
		
	i = 0
	file_object = open(frequence_file,'rU')

	try:
	    for line in file_object:
	        if(i == 0):
	                i = i + 1
	                continue
	        array_l = line.split( );
	        l_matrix[int(array_l[0])-1][array_l[1]] = float(array_l[2])
	finally:
	     file_object.close()

	for i in fastas:
		name, sequence = i[0], i[1]
		code = []

		for j in range(len(sequence)):

			score = 0
			for key in l_matrix[j].keys():
				M = blosum_matrix[blosum_id.index(sequence[j])][blosum_id.index(key)]
        		        Sim = (M-np.amin(blosum_matrix))/(np.amax(blosum_matrix)-np.amin(blosum_matrix))
				score = score + l_matrix[j][key]*Sim
			code.append(score)

		encodings.append(code)

	return encodings
