#!/usr/bin/env python
#_*_coding:utf-8_*_
# Authors: Superzchen

import re
import index_list
from util import *

def PseKRAAC(fastas, grouptype, subtype, raactype, ktuple, glValue):

	if ktuple != 1 and ktuple != 2 and ktuple != 3:
		print('Error: the "--kValue" value must be 1 or 2 or 3.')
		return 0
	AAGroup = eval('index_list.AAGroup_'+grouptype)
	if raactype not in AAGroup:
		print('Error: the "--raactype" value is not correct.')
		return 0

	# index each amino acids to their group
	myDict = {}
	for i in range(len(AAGroup[raactype])):
		for aa in AAGroup[raactype][i]:
			myDict[aa] = i

	gDict = {}
	gNames = []
	for i in range(len(AAGroup[raactype])):
		gDict[i] = 'T.G.'+str(i+1)
		gNames.append('T.G.'+str(i+1))

	encodings = []
	if subtype == 'g-gap':
		encodings = gapModel(fastas, myDict, gDict, gNames, ktuple, int(glValue))
	else:
		encodings = lambdaModel(fastas, myDict, gDict, gNames, ktuple, int(glValue))

	return encodings