#!/usr/bin/env python
#_*_coding:utf-8_*_
# Authors: Superzchen

from __future__ import division
import sys, platform, os, re
import numpy as np
import util

def SOCNumber(fastas, nlag=30, **kw):
	if nlag <= 0:
		print "parameters nlag is required. The default value of nlag is 30."
		nlag = 30
	if util.minSequenceLengthWithNormalAA(fastas) < nlag + 1:
		print('Error: all the sequence length should be larger than the nlag+1: ' + str(nlag + 1) + '\n\n')
		return 0

	dataFile = os.path.dirname(os.path.realpath(__file__))  + r'\data\Schneider-Wrede.txt' if platform.system() == 'Windows' else os.path.dirname(os.path.realpath(__file__))  + '/data/Schneider-Wrede.txt'
	dataFile1 = os.path.dirname(os.path.realpath(__file__))  + r'\data\Grantham.txt' if platform.system() == 'Windows' else os.path.dirname(os.path.realpath(__file__))  + '/data/Grantham.txt'
	AA = 'ACDEFGHIKLMNPQRSTVWY'
	AA1 = 'ARNDCQEGHILKMFPSTWYV'

	DictAA = {}
	for i in range(len(AA)):
		DictAA[AA[i]] = i

	DictAA1 = {}
	for i in range(len(AA1)):
		DictAA1[AA1[i]] = i

	with open(dataFile) as f:
		records = f.readlines()[1:]
	AADistance = []
	for i in records:
		array = i.rstrip().split()[1:] if i.rstrip() != '' else None
		AADistance.append(array)
	AADistance = np.array(
		[float(AADistance[i][j]) for i in range(len(AADistance)) for j in range(len(AADistance[i]))]).reshape((20, 20))

	with open(dataFile1) as f:
		records = f.readlines()[1:]
	AADistance1 = []
	for i in records:
		array = i.rstrip().split()[1:] if i.rstrip() != '' else None
		AADistance1.append(array)
	AADistance1 = np.array(
		[float(AADistance1[i][j]) for i in range(len(AADistance1)) for j in range(len(AADistance1[i]))]).reshape(
		(20, 20))

	encodings = []

	for i in fastas:
		name, sequence = i[0], re.sub('-', '', i[1])
		code = []
		for n in range(1, nlag + 1):
			code.append(sum(
				[AADistance[DictAA[sequence[j]]][DictAA[sequence[j + n]]] ** 2 for j in range(len(sequence) - n)]) / (
						len(sequence) - n))

		for n in range(1, nlag + 1):
			code.append(sum([AADistance1[DictAA1[sequence[j]]][DictAA1[sequence[j + n]]] ** 2 for j in
							 range(len(sequence) - n)]) / (len(sequence) - n))
		encodings.append(code)
	return encodings

