#!/usr/bin/env python
#_*_coding:utf-8_*_
# Authors: Superzchen

from __future__ import division
import sys, os, numpy
import util

def SSEB(fastas, ssDir):
	if util.checkFasta(fastas) == False:
		print('Error: for "SSEB" encoding, the input fasta sequences should be with equal length. \n\n')
		return 0
	if ssDir == None:
		print('Error: please specify the directory of predicted protein disorder files by "--path"')
		return 0

	encodings = []

	for i in fastas:
		name, sequence = i[0].replace(".","").replace("|",""), i[1]
		code = []
		if os.path.exists(ssDir + '/' + name + '.ss2') == True:
			with open(ssDir + '/' + name + '.ss2') as f:
				records = f.readlines()[2:]
		elif os.path.exists(ssDir + '/' + name + '.spXout') == True:
			with open(ssDir + '/' + name + '.spXout') as f:
				records = f.readlines()[1:]
		else:
			print('Error: the predicted secondary structure (.ss2 or .spXout) for protein ' + name + ' does not exist.')
			return 0

		proteinSeq = ''
		SSE = []
		myDict = {'H':[0, 0, 1], 'E':[0, 1, 0], 'C':[1, 0, 0]}
		for line in records:
			array = line.strip().split() if line.rstrip() != '' else None
			proteinSeq = proteinSeq + array[1]
			SSE.append(array[2])

		pos = proteinSeq.find(sequence)
		if pos == -1:
			print('Warning: could not find the peptide in proteins.\n\n')
			return 0
			#code = numpy.zeros(3*util.minSequenceLengthWithNormalAA(fastas))
		else:
			for p in range(pos, pos + len(sequence)):
				code = code + myDict[SSE[p]]
		encodings.append(code)

	return encodings