#!/usr/bin/env python
#_*_coding:utf-8_*_
# Authors: Superzchen

from __future__ import division
import os, numpy

def calculateSSE(pos, end, SSE):
	newValues = SSE[pos:end]
	return [newValues.count('H')/(end-pos), newValues.count('E')/(end-pos), newValues.count('C')/(end-pos)]

def SSEC(fastas, ssDir):
	if ssDir == None:
		print('Error: please specify the directory of predicted protein disorder files by "--path"')
		return 0

	encodings = []

	for i in fastas:
		name, sequence = i[0].replace(".","").replace("|",""), i[1]
		code = []

		if os.path.exists(ssDir + '/' + name + '.ss2') == True:
			with open(ssDir + '/' + name + '.ss2') as f:
				records = f.readlines()[2:]
		elif os.path.exists(ssDir + '/' + name + '.spXout') == True:
			with open(ssDir + '/' + name + '.spXout') as f:
				records = f.readlines()[1:]
		else:
			print('Error: the predicted secondary structure (.ss2 or .spXout) for protein ' + name + ' does not exist.')
			return 0

		proteinSeq = ''
		SSE = []
		for line in records:
			array = line.strip().split() if line.rstrip() != '' else None
			proteinSeq = proteinSeq + array[1]
			SSE.append(array[2])

		pos = proteinSeq.find(sequence)
		if pos == -1:
			print('Warning: could not find the peptide in proteins.\n\n')
			return 0
			#code = numpy.zeros(3)
		else:
			code = code + calculateSSE(pos, pos+len(sequence), SSE)
		encodings.append(code)

	return encodings