#!/usr/bin/env python
#_*_coding:utf-8_*_
# Authors: Superzchen

from __future__ import division
import sys, os, re
import util, numpy

def TA(fastas, disDir):
	if util.checkFasta(fastas) == False:
		print('Error: for "TA" encoding, the input fasta sequences should be with equal length. \n\n')
		return 0

	encodings = []
	
	if disDir == None:
		print('Error: please specify the directory of predicted protein TA file by "--path"')
		return 0
	for i in fastas:
		name, sequence = i[0].replace(".","").replace("|",""), i[1]
		code = []
		if os.path.exists(disDir + '/' + name + '.spXout') == False:
			print('Error: the predicted TA information file (.spXout) for protein ' + name + ' does not exist.')
			return 0

		with open(disDir + '/' + name + '.spXout') as f:
			records = f.readlines()[1:]

		proteinSeq = ''
		asaValue = []
		for line in records:
			array = line.strip().split() if line.strip() != '' else None
			proteinSeq = proteinSeq + array[1]
			asaValue.append(array[3:5])
		pos = proteinSeq.find(sequence)
		if pos == -1:
			#code = numpy.zeros(2*util.minSequenceLengthWithNormalAA(fastas))
			print('Warning: could not find the peptide in proteins.\n\n')
			return 0
		else:
			for p in range(pos, pos+len(sequence)):
				code.append(float(asaValue[p][0]))
				code.append(float(asaValue[p][1]))
		encodings.append(code)

	return encodings
