#! /usr/bin/env python
# -*- coding: utf-8 -*-
# Authors: Chris (chris@nohup.cc) & Young (young@nohup.cc)

import fileinput
import numpy as np
import util

def TPC_LOOP(finalist):
    encodings=[]
    for fi in finalist:
        input_matrix=fileinput.input(fi)
        input_matrix=util.readToMatrix(input_matrix)
        encodings.append(tpc(input_matrix)[0])
    return encodings

def tpc(input_matrix):
    #print "start tpc function"
    PART=0
    STEP=1
    ID=0
    KEY=1
    matrix_final=util.preHandleColumns(input_matrix, STEP, PART, ID)
    matrix_tmp=[0.0] * 20
    matrix_tmp=np.array(matrix_tmp)
    for i in range(20):
        matrix_tmp=map(sum, zip(matrix_final[i], matrix_tmp))
    for i in range(20):
        for j in range(20):
            matrix_final[i][j]=matrix_final[i][j]/matrix_tmp[j]
    tpc_vector = util.average(matrix_final, 1.0)
    #print "end tpc function"
    return tpc_vector