#! /usr/bin/env python
# -*- coding: utf-8 -*-
"""
@author: Fule Liu, Nackel, luo, Hao Wu
"""

def make_cc_vec(sequence_list, lag, phyche_value, k):

    if lag <= 0 :
        print "parameters lag is required. The default value of lag is 2."
        lag = 2
        
    phyche_values = list(phyche_value.values())
    len_phyche_value = len(phyche_values[0])
    vec_cc = []
    for sequence in sequence_list:
        len_seq = len(sequence[1])
        each_vec = []

        for temp_lag in range(1, lag + 1):
            for i1 in range(len_phyche_value):
                for i2 in range(len_phyche_value):
                    if i1 != i2:
                        # Calculate average phyche_value for a nucleotide.
                        ave_phyche_value1 = 0.0
                        ave_phyche_value2 = 0.0
                        for j in range(len_seq - k):
                            nucleotide = sequence[1][j: j + k]
                            ave_phyche_value1 += float(phyche_value[nucleotide][i1])
                            ave_phyche_value2 += float(phyche_value[nucleotide][i2])
                        ave_phyche_value1 /= (len_seq - k)
                        ave_phyche_value2 /= (len_seq - k)

                        # Calculate the vector.
                        temp_sum = 0.0
                        for j in range(len_seq - temp_lag - k + 1):
                            nucleotide1 = sequence[1][j: j + k]
                            nucleotide2 = sequence[1][j + temp_lag: j + temp_lag + k]
                            temp_sum += (float(phyche_value[nucleotide1][i1]) - ave_phyche_value1) * \
                                        (float(phyche_value[nucleotide2][i2]) - ave_phyche_value2)
                        each_vec.append(round(temp_sum / (len_seq - temp_lag - k + 1), 8))

        vec_cc.append(each_vec)

    return vec_cc