"""
@author: Fule Liu, Nackel, luo, Hao Wu
"""
import util
import index_list
import re,sys,os

def autocorrelation(fastas, k, l, phyche_list_file, all_prop):
    if l <= 0 :
        print "parameters lamada is required. The default value of lamada is 1."
        l = 1
    if l < 0 or l > 10:
        sys.exit("Error! The value of lamada should be larger than 0 and smaller than 10.")
    props = ''
    alphabet = index_list.RNA
    if all_prop == 'True':
        props = index_list.ALL_RNA_IND
    elif phyche_list_file == '':
        print "parameters phyche_list is required. The default value of phyche_list is ['Rise (RNA)', 'Roll (RNA)', 'Shift (RNA)', 'Slide (RNA)', 'Tilt (RNA)', 'Twist (RNA)']."
        props=index_list.DEFAULT_RNA_IND
    else:
        props = util.read_index(phyche_list_file)
    # Getting supporting info from files
    full_path = os.path.realpath(__file__)
    if k == 2 and alphabet == index_list.RNA:
        SupFileName = "%s/data/Supporting_Information_S1_RNA.txt" % os.path.dirname(full_path)
    elif k == 2 and alphabet == index_list.DNA:
        SupFileName = "%s/data/Supporting_Information_S1_DNA.txt" % os.path.dirname(full_path)
    elif k == 3 and alphabet == index_list.DNA:
        SupFileName = "%s/data/Supporting_Information_S3_DNA.txt" % os.path.dirname(full_path)
    SupFile = open(SupFileName, 'r')
    supInfo = SupFile.read()
    o = re.search('Physicochemical properties\,(.+)\n', supInfo)
    olinucs = ''
    if o:
        olinucs = o.group(1).rstrip()
    SupFile.close()
    # Writing to output file
    m = 0
    vectors = []
    for sequence in fastas:
        length = len(sequence[1])
        seq = util.sepSequence(sequence[1], k)
        values = []
        for prop in props:
            #check if prop is in supinfo
            if prop in index_list.ALL_DI_RNA_IND:
                value = float("%.3f" % geary(seq, olinucs, length, k, l, prop, supInfo))
                values.append(value)
            else:
                print "%s is not in Physicochemical properties list." % prop
        vectors.append(values)
        m += 1
    return vectors

def geary(seq, olinucs, length, k, l, prop, supInfo):
    lim = length - k + 1
    limit = length - k - l + 1
    b = 1
    sqr = 0
    while b < limit or b == limit:
        current = util.getSpecificValue(seq[b - 1], olinucs, prop, supInfo)
        # hn(seq[b-1],prop,SupFileName)
        next = util.getSpecificValue(seq[b + l - 1], olinucs, prop, supInfo)
        # hn(seq[b+l-1],prop,SupFileName)
        sqr = sqr + ((current - next) * (current - next))
        b = b + 1
    top = sqr * lim
    limit2 = (length - k - l + 1)
    c = 1
    sqr2 = 0
    while c < limit2 or c == limit2:
        # current = hn(seq[c-1],prop,SupFileName)
        current = util.getSpecificValue(seq[c - 1], olinucs, prop, supInfo)
        avg = util.avgP(seq, olinucs, length, k, prop, supInfo)
        sqr2 = sqr2 + (current - avg) * (current - avg)
        c = c + 1
    bottom = sqr2 * limit * 2
    final = float((top / bottom) * 1000) / 1000.0
    return final