#! /usr/bin/env python
# -*- coding: utf-8 -*-
"""
@author: Fule Liu, Nackel, luo, Hao Wu
"""

import index_list,sys,util
from numpy import array
import numpy as np
from itertools import combinations, combinations_with_replacement, permutations, product

def getMismatchProfileMatrix(fastas, k, m):
    if k <= 0:
        print "parameters k is required. The default value of k is 3."
        k = 3
    if m <= 0:
        print "parameters m is required. The default value of m is 1."
        m = 1
    if m >= k:
        sys.exit("Error! parameters m should be less than parameter k.")
    alphabet = index_list.RNA
    alphabet = list(alphabet)
    p = len(alphabet)
    kmerdict = util.getKmerDict(alphabet, k)
    features = []
    if m==0 and m < k:
        for sequence in fastas:
            vector=getSpectrumProfileVector(sequence[1], kmerdict, p, k)
            features.append(vector)
    elif m > 0 and m < k:
        for sequence in fastas:
            vector=getMismatchProfileVector(sequence[1], alphabet, kmerdict, p, k)
            features.append(vector)   
    return array(features)


def getSpectrumProfileVector(sequence, kmerdict, p, k):    
    vector = np.zeros((1, p**k))
    n = len(sequence)
    for i in range(n-k+1):
        subsequence=sequence[i:i+k]
        position=kmerdict.get(subsequence)
        vector[0,position] += 1
    return list(vector[0])


def getMismatchProfileVector(sequence, alphabet, kmerdict, p, k): 
    n = len(sequence)
    vector = np.zeros((1, p**k))
    for i in range(n-k+1):
        subsequence = sequence[i:i+k]
        position = kmerdict.get(subsequence)
        vector[0, position]+=1
        for j in range(k):
            substitution = subsequence
            for letter in list(set(alphabet)^set(subsequence[j])):
                substitution = list(substitution)
                substitution[j] = letter
                substitution = ''.join(substitution)
                position = kmerdict.get(substitution)
                vector[0,position] += 1    
    return list(vector[0])